Merge 'normalize-win-paths' into HEAD
[git/mingw/4msysgit.git] / t / test-lib.sh
blob2d63a49a4233168f5afed90271a65c8bacafb9f6
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # for git on windows so stdin will not be misdetected as attached to a
19 # terminal
20 exec < /dev/null
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # Test the binaries we have just built. The tests are kept in
26 # t/ subdirectory and are run in 'trash directory' subdirectory.
27 if test -z "$TEST_DIRECTORY"
28 then
29 # We allow tests to override this, in case they want to run tests
30 # outside of t/, e.g. for running tests on the test library
31 # itself.
32 TEST_DIRECTORY=$(pwd)
33 else
34 # ensure that TEST_DIRECTORY is an absolute path so that it
35 # is valid even if the current working directory is changed
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
44 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
46 ################################################################
47 # It appears that people try to run tests without building...
48 "$GIT_BUILD_DIR/git" >/dev/null
49 if test $? != 1
50 then
51 echo >&2 'error: you do not seem to have built git yet.'
52 exit 1
55 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
56 export PERL_PATH SHELL_PATH
58 # if --tee was passed, write the output not only to the terminal, but
59 # additionally to the file test-results/$BASENAME.out, too.
60 case "$GIT_TEST_TEE_STARTED, $* " in
61 done,*)
62 # do not redirect again
64 *' --tee '*|*' --va'*)
65 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
66 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
67 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
68 echo $? > $BASE.exit) | tee $BASE.out
69 test "$(cat $BASE.exit)" = 0
70 exit
72 esac
74 # For repeatability, reset the environment to known value.
75 LANG=C
76 LC_ALL=C
77 PAGER=cat
78 TZ=UTC
79 TERM=dumb
80 export LANG LC_ALL PAGER TERM TZ
81 EDITOR=:
82 # A call to "unset" with no arguments causes at least Solaris 10
83 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
84 # deriving from the command substitution clustered with the other
85 # ones.
86 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
87 my @env = keys %ENV;
88 my $ok = join("|", qw(
89 TRACE
90 DEBUG
91 USE_LOOKUP
92 TEST
93 .*_TEST
94 PROVE
95 VALGRIND
96 UNZIP
97 PERF_
98 ));
99 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
100 print join("\n", @vars);
102 unset XDG_CONFIG_HOME
103 unset GITPERLLIB
104 GIT_AUTHOR_EMAIL=author@example.com
105 GIT_AUTHOR_NAME='A U Thor'
106 GIT_COMMITTER_EMAIL=committer@example.com
107 GIT_COMMITTER_NAME='C O Mitter'
108 GIT_MERGE_VERBOSITY=5
109 GIT_MERGE_AUTOEDIT=no
110 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
111 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
112 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
113 export EDITOR
115 # Add libc MALLOC and MALLOC_PERTURB test
116 # only if we are not executing the test with valgrind
117 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
118 test -n "$TEST_NO_MALLOC_CHECK"
119 then
120 setup_malloc_check () {
121 : nothing
123 teardown_malloc_check () {
124 : nothing
126 else
127 setup_malloc_check () {
128 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
129 export MALLOC_CHECK_ MALLOC_PERTURB_
131 teardown_malloc_check () {
132 unset MALLOC_CHECK_ MALLOC_PERTURB_
136 # Protect ourselves from common misconfiguration to export
137 # CDPATH into the environment
138 unset CDPATH
140 unset GREP_OPTIONS
141 unset UNZIP
143 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
144 1|2|true)
145 echo "* warning: Some tests will not work if GIT_TRACE" \
146 "is set as to trace on STDERR ! *"
147 echo "* warning: Please set GIT_TRACE to something" \
148 "other than 1, 2 or true ! *"
150 esac
152 # Convenience
154 # A regexp to match 5 and 40 hexdigits
155 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
156 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
158 # Zero SHA-1
159 _z40=0000000000000000000000000000000000000000
161 # Line feed
162 LF='
165 export _x05 _x40 _z40 LF
167 # Each test should start with something like this, after copyright notices:
169 # test_description='Description of this test...
170 # This test checks if command xyzzy does the right thing...
172 # . ./test-lib.sh
173 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
174 TERM=$ORIGINAL_TERM &&
175 export TERM &&
176 [ -t 1 ] &&
177 tput bold >/dev/null 2>&1 &&
178 tput setaf 1 >/dev/null 2>&1 &&
179 tput sgr0 >/dev/null 2>&1
180 ) &&
181 color=t
183 while test "$#" -ne 0
185 case "$1" in
186 -d|--d|--de|--deb|--debu|--debug)
187 debug=t; shift ;;
188 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
189 immediate=t; shift ;;
190 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
191 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
192 -h|--h|--he|--hel|--help)
193 help=t; shift ;;
194 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
195 verbose=t; shift ;;
196 --verbose-only=*)
197 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
198 shift ;;
199 -q|--q|--qu|--qui|--quie|--quiet)
200 # Ignore --quiet under a TAP::Harness. Saying how many tests
201 # passed without the ok/not ok details is always an error.
202 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
203 --with-dashes)
204 with_dashes=t; shift ;;
205 --no-color)
206 color=; shift ;;
207 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
208 valgrind=memcheck
209 shift ;;
210 --valgrind=*)
211 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
213 --valgrind-only=*)
214 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
215 shift ;;
216 --tee)
217 shift ;; # was handled already
218 --root=*)
219 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
220 shift ;;
222 echo "error: unknown test option '$1'" >&2; exit 1 ;;
223 esac
224 done
226 if test -n "$valgrind_only"
227 then
228 test -z "$valgrind" && valgrind=memcheck
229 test -z "$verbose" && verbose_only="$valgrind_only"
230 elif test -n "$valgrind"
231 then
232 verbose=t
235 if test -n "$color"
236 then
237 say_color () {
239 TERM=$ORIGINAL_TERM
240 export TERM
241 case "$1" in
242 error)
243 tput bold; tput setaf 1;; # bold red
244 skip)
245 tput setaf 4;; # blue
246 warn)
247 tput setaf 3;; # brown/yellow
248 pass)
249 tput setaf 2;; # green
250 info)
251 tput setaf 6;; # cyan
253 test -n "$quiet" && return;;
254 esac
255 shift
256 printf "%s" "$*"
257 tput sgr0
258 echo
261 else
262 say_color() {
263 test -z "$1" && test -n "$quiet" && return
264 shift
265 printf "%s\n" "$*"
269 error () {
270 say_color error "error: $*"
271 GIT_EXIT_OK=t
272 exit 1
275 say () {
276 say_color info "$*"
279 test "${test_description}" != "" ||
280 error "Test script did not set test_description."
282 if test "$help" = "t"
283 then
284 printf '%s\n' "$test_description"
285 exit 0
288 exec 5>&1
289 exec 6<&0
290 if test "$verbose" = "t"
291 then
292 exec 4>&2 3>&1
293 else
294 exec 4>/dev/null 3>/dev/null
297 test_failure=0
298 test_count=0
299 test_fixed=0
300 test_broken=0
301 test_success=0
303 test_external_has_tap=0
305 die () {
306 code=$?
307 if test -n "$GIT_EXIT_OK"
308 then
309 exit $code
310 else
311 echo >&5 "FATAL: Unexpected exit with code $code"
312 exit 1
316 GIT_EXIT_OK=
317 trap 'die' EXIT
319 # The user-facing functions are loaded from a separate file so that
320 # test_perf subshells can have them too
321 . "$TEST_DIRECTORY/test-lib-functions.sh"
323 # You are not expected to call test_ok_ and test_failure_ directly, use
324 # the test_expect_* functions instead.
326 test_ok_ () {
327 test_success=$(($test_success + 1))
328 say_color "" "ok $test_count - $@"
331 test_failure_ () {
332 test_failure=$(($test_failure + 1))
333 say_color error "not ok $test_count - $1"
334 shift
335 printf '%s\n' "$*" | sed -e 's/^/# /'
336 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
339 test_known_broken_ok_ () {
340 test_fixed=$(($test_fixed+1))
341 say_color error "ok $test_count - $@ # TODO known breakage vanished"
344 test_known_broken_failure_ () {
345 test_broken=$(($test_broken+1))
346 say_color warn "not ok $test_count - $@ # TODO known breakage"
349 test_debug () {
350 test "$debug" = "" || eval "$1"
353 match_pattern_list () {
354 arg="$1"
355 shift
356 test -z "$*" && return 1
357 for pattern_
359 case "$arg" in
360 $pattern_)
361 return 0
362 esac
363 done
364 return 1
367 maybe_teardown_verbose () {
368 test -z "$verbose_only" && return
369 exec 4>/dev/null 3>/dev/null
370 verbose=
373 last_verbose=t
374 maybe_setup_verbose () {
375 test -z "$verbose_only" && return
376 if match_pattern_list $test_count $verbose_only
377 then
378 exec 4>&2 3>&1
379 # Emit a delimiting blank line when going from
380 # non-verbose to verbose. Within verbose mode the
381 # delimiter is printed by test_expect_*. The choice
382 # of the initial $last_verbose is such that before
383 # test 1, we do not print it.
384 test -z "$last_verbose" && echo >&3 ""
385 verbose=t
386 else
387 exec 4>/dev/null 3>/dev/null
388 verbose=
390 last_verbose=$verbose
393 maybe_teardown_valgrind () {
394 test -z "$GIT_VALGRIND" && return
395 GIT_VALGRIND_ENABLED=
398 maybe_setup_valgrind () {
399 test -z "$GIT_VALGRIND" && return
400 if test -z "$valgrind_only"
401 then
402 GIT_VALGRIND_ENABLED=t
403 return
405 GIT_VALGRIND_ENABLED=
406 if match_pattern_list $test_count $valgrind_only
407 then
408 GIT_VALGRIND_ENABLED=t
412 test_eval_ () {
413 # This is a separate function because some tests use
414 # "return" to end a test_expect_success block early.
415 eval </dev/null >&3 2>&4 "$*"
418 test_run_ () {
419 test_cleanup=:
420 expecting_failure=$2
421 setup_malloc_check
422 test_eval_ "$1"
423 eval_ret=$?
424 teardown_malloc_check
426 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
427 then
428 setup_malloc_check
429 test_eval_ "$test_cleanup"
430 teardown_malloc_check
432 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
433 then
434 echo ""
436 return "$eval_ret"
439 test_start_ () {
440 test_count=$(($test_count+1))
441 maybe_setup_verbose
442 maybe_setup_valgrind
445 test_finish_ () {
446 echo >&3 ""
447 maybe_teardown_valgrind
448 maybe_teardown_verbose
451 test_skip () {
452 to_skip=
453 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
454 then
455 to_skip=t
457 if test -z "$to_skip" && test -n "$test_prereq" &&
458 ! test_have_prereq "$test_prereq"
459 then
460 to_skip=t
462 case "$to_skip" in
464 of_prereq=
465 if test "$missing_prereq" != "$test_prereq"
466 then
467 of_prereq=" of $test_prereq"
470 say_color skip >&3 "skipping test: $@"
471 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
472 : true
475 false
477 esac
480 # stub; perf-lib overrides it
481 test_at_end_hook_ () {
485 test_done () {
486 GIT_EXIT_OK=t
488 if test -z "$HARNESS_ACTIVE"
489 then
490 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
491 mkdir -p "$test_results_dir"
492 base=${0##*/}
493 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
495 cat >>"$test_results_path" <<-EOF
496 total $test_count
497 success $test_success
498 fixed $test_fixed
499 broken $test_broken
500 failed $test_failure
505 if test "$test_fixed" != 0
506 then
507 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
509 if test "$test_broken" != 0
510 then
511 say_color warn "# still have $test_broken known breakage(s)"
513 if test "$test_broken" != 0 || test "$test_fixed" != 0
514 then
515 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
516 msg="remaining $test_remaining test(s)"
517 else
518 test_remaining=$test_count
519 msg="$test_count test(s)"
521 case "$test_failure" in
523 # Maybe print SKIP message
524 if test -n "$skip_all" && test $test_count -gt 0
525 then
526 error "Can't use skip_all after running some tests"
528 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
530 if test $test_external_has_tap -eq 0
531 then
532 if test $test_remaining -gt 0
533 then
534 say_color pass "# passed all $msg"
536 say "1..$test_count$skip_all"
539 test -d "$remove_trash" &&
540 cd "$(dirname "$remove_trash")" &&
541 rm -rf "$(basename "$remove_trash")"
543 test_at_end_hook_
545 exit 0 ;;
548 if test $test_external_has_tap -eq 0
549 then
550 say_color error "# failed $test_failure among $msg"
551 say "1..$test_count"
554 exit 1 ;;
556 esac
559 if test -n "$valgrind"
560 then
561 make_symlink () {
562 test -h "$2" &&
563 test "$1" = "$(readlink "$2")" || {
564 # be super paranoid
565 if mkdir "$2".lock
566 then
567 rm -f "$2" &&
568 ln -s "$1" "$2" &&
569 rm -r "$2".lock
570 else
571 while test -d "$2".lock
573 say "Waiting for lock on $2."
574 sleep 1
575 done
580 make_valgrind_symlink () {
581 # handle only executables, unless they are shell libraries that
582 # need to be in the exec-path.
583 test -x "$1" ||
584 test "# " = "$(head -c 2 <"$1")" ||
585 return;
587 base=$(basename "$1")
588 symlink_target=$GIT_BUILD_DIR/$base
589 # do not override scripts
590 if test -x "$symlink_target" &&
591 test ! -d "$symlink_target" &&
592 test "#!" != "$(head -c 2 < "$symlink_target")"
593 then
594 symlink_target=../valgrind.sh
596 case "$base" in
597 *.sh|*.perl)
598 symlink_target=../unprocessed-script
599 esac
600 # create the link, or replace it if it is out of date
601 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
604 # override all git executables in TEST_DIRECTORY/..
605 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
606 mkdir -p "$GIT_VALGRIND"/bin
607 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
609 make_valgrind_symlink $file
610 done
611 # special-case the mergetools loadables
612 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
613 OLDIFS=$IFS
614 IFS=:
615 for path in $PATH
617 ls "$path"/git-* 2> /dev/null |
618 while read file
620 make_valgrind_symlink "$file"
621 done
622 done
623 IFS=$OLDIFS
624 PATH=$GIT_VALGRIND/bin:$PATH
625 GIT_EXEC_PATH=$GIT_VALGRIND/bin
626 export GIT_VALGRIND
627 GIT_VALGRIND_MODE="$valgrind"
628 export GIT_VALGRIND_MODE
629 GIT_VALGRIND_ENABLED=t
630 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
631 export GIT_VALGRIND_ENABLED
632 elif test -n "$GIT_TEST_INSTALLED"
633 then
634 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
635 error "Cannot run git from $GIT_TEST_INSTALLED."
636 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
637 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
638 else # normal case, use ../bin-wrappers only unless $with_dashes:
639 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
640 if ! test -x "$git_bin_dir/git"
641 then
642 if test -z "$with_dashes"
643 then
644 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
646 with_dashes=t
648 PATH="$git_bin_dir:$PATH"
649 GIT_EXEC_PATH=$GIT_BUILD_DIR
650 if test -n "$with_dashes"
651 then
652 PATH="$GIT_BUILD_DIR:$PATH"
655 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
656 unset GIT_CONFIG
657 GIT_CONFIG_NOSYSTEM=1
658 GIT_ATTR_NOSYSTEM=1
659 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
661 if test -z "$GIT_TEST_CMP"
662 then
663 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
664 then
665 GIT_TEST_CMP="$DIFF -c"
666 else
667 GIT_TEST_CMP="$DIFF -u"
671 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
672 export GITPERLLIB
673 test -d "$GIT_BUILD_DIR"/templates/blt || {
674 error "You haven't built things yet, have you?"
677 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
678 then
679 echo >&2 'You need to build test-chmtime:'
680 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
681 exit 1
684 # Test repository
685 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
686 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
687 case "$TRASH_DIRECTORY" in
688 /*) ;; # absolute path is good
689 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
690 esac
691 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
692 rm -fr "$TRASH_DIRECTORY" || {
693 GIT_EXIT_OK=t
694 echo >&5 "FATAL: Cannot prepare test area"
695 exit 1
698 HOME="$TRASH_DIRECTORY"
699 export HOME
701 if test -z "$TEST_NO_CREATE_REPO"
702 then
703 test_create_repo "$TRASH_DIRECTORY"
704 else
705 mkdir -p "$TRASH_DIRECTORY"
707 # Use -P to resolve symlinks in our working directory so that the cwd
708 # in subprocesses like git equals our $PWD (for pathname comparisons).
709 cd -P "$TRASH_DIRECTORY" || exit 1
711 this_test=${0##*/}
712 this_test=${this_test%%-*}
713 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
714 then
715 say_color info >&3 "skipping test $this_test altogether"
716 skip_all="skip all tests in $this_test"
717 test_done
720 # Provide an implementation of the 'yes' utility
721 yes () {
722 if test $# = 0
723 then
725 else
726 y="$*"
729 while echo "$y"
732 done
735 # Fix some commands on Windows
736 case $(uname -s) in
737 *MINGW*)
738 # Windows has its own (incompatible) sort and find
739 sort () {
740 /usr/bin/sort "$@"
742 find () {
743 /usr/bin/find "$@"
745 sum () {
746 md5sum "$@"
748 # git sees Windows-style pwd
749 pwd () {
750 builtin pwd -W
752 # no POSIX permissions
753 # backslashes in pathspec are converted to '/'
754 # exec does not inherit the PID
755 test_set_prereq MINGW
756 test_set_prereq NOT_CYGWIN
757 test_set_prereq NATIVE_CRLF
758 test_set_prereq SED_STRIPS_CR
759 test_set_prereq GREP_STRIPS_CR
760 GIT_TEST_CMP=mingw_test_cmp
762 *CYGWIN*)
763 test_set_prereq POSIXPERM
764 test_set_prereq EXECKEEPSPID
765 test_set_prereq NOT_MINGW
766 test_set_prereq CYGWIN
767 test_set_prereq SED_STRIPS_CR
768 test_set_prereq GREP_STRIPS_CR
771 test_set_prereq POSIXPERM
772 test_set_prereq BSLASHPSPEC
773 test_set_prereq EXECKEEPSPID
774 test_set_prereq NOT_MINGW
775 test_set_prereq NOT_CYGWIN
777 esac
779 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
780 test -z "$NO_PERL" && test_set_prereq PERL
781 test -z "$NO_PYTHON" && test_set_prereq PYTHON
782 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
783 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
785 # Can we rely on git's output in the C locale?
786 if test -n "$GETTEXT_POISON"
787 then
788 GIT_GETTEXT_POISON=YesPlease
789 export GIT_GETTEXT_POISON
790 test_set_prereq GETTEXT_POISON
791 else
792 test_set_prereq C_LOCALE_OUTPUT
795 # Use this instead of test_cmp to compare files that contain expected and
796 # actual output from git commands that can be translated. When running
797 # under GETTEXT_POISON this pretends that the command produced expected
798 # results.
799 test_i18ncmp () {
800 test -n "$GETTEXT_POISON" || test_cmp "$@"
803 # Use this instead of "grep expected-string actual" to see if the
804 # output from a git command that can be translated either contains an
805 # expected string, or does not contain an unwanted one. When running
806 # under GETTEXT_POISON this pretends that the command produced expected
807 # results.
808 test_i18ngrep () {
809 if test -n "$GETTEXT_POISON"
810 then
811 : # pretend success
812 elif test "x!" = "x$1"
813 then
814 shift
815 ! grep "$@"
816 else
817 grep "$@"
821 test_lazy_prereq PIPE '
822 # test whether the filesystem supports FIFOs
823 case $(uname -s) in
824 CYGWIN*)
825 false
828 rm -f testfifo && mkfifo testfifo
830 esac
833 test_lazy_prereq SYMLINKS '
834 # test whether the filesystem supports symbolic links
835 ln -s x y && test -h y
838 test_lazy_prereq FILEMODE '
839 test "$(git config --bool core.filemode)" = true
842 test_lazy_prereq CASE_INSENSITIVE_FS '
843 echo good >CamelCase &&
844 echo bad >camelcase &&
845 test "$(cat CamelCase)" != good
848 test_lazy_prereq UTF8_NFD_TO_NFC '
849 # check whether FS converts nfd unicode to nfc
850 auml=$(printf "\303\244")
851 aumlcdiar=$(printf "\141\314\210")
852 >"$auml" &&
853 case "$(echo *)" in
854 "$aumlcdiar")
855 true ;;
857 false ;;
858 esac
861 test_lazy_prereq AUTOIDENT '
862 sane_unset GIT_AUTHOR_NAME &&
863 sane_unset GIT_AUTHOR_EMAIL &&
864 git var GIT_AUTHOR_IDENT
867 # When the tests are run as root, permission tests will report that
868 # things are writable when they shouldn't be.
869 test -w / || test_set_prereq SANITY
871 GIT_UNZIP=${GIT_UNZIP:-unzip}
872 test_lazy_prereq UNZIP '
873 "$GIT_UNZIP" -v
874 test $? -ne 127